/******************************************************************************
* Copyright (C) 2008 - Ikaro Games   www.ikarogames.com                       *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                             *
*                                                                             *
*       generated by dia/DAOcodegen.py                                        *
*       Version: 1.4                                                          *
******************************************************************************/

#include <stdlib.h>

#include "CPfEquiposDAOSQLiteEntity.h"
#include "../../../../utils/CLog.h"

CPfEquiposDAOSQLiteEntity::CPfEquiposDAOSQLiteEntity(sqlite3 *database)
{
    m_database = database;
}

CPfEquiposDAOSQLiteEntity::~CPfEquiposDAOSQLiteEntity()
{
}

bool CPfEquiposDAOSQLiteEntity::deleteReg(CPfEquipos *reg)
{
    std::string sql("DELETE FROM PF_EQUIPOS WHERE X_EQUIPO=");
    sql = sql+"'"+reg->getXEquipo()->c_str()+"'";
    return exec(sql);
}

bool CPfEquiposDAOSQLiteEntity::insertReg(CPfEquipos *reg)
{
    std::string sql("INSERT INTO PF_EQUIPOS (X_FK_PAIS,X_EQUIPO,S_EQUIPO,S_RUTA_ESCUDO) VALUES (");
    sql = sql+" '"+reg->getXFkPais()->c_str()+"'";
    sql = sql+",'"+reg->getXEquipo()->c_str()+"'";
    sql = sql+",'"+reg->getSEquipo()->c_str()+"'";
    sql = sql+",'"+reg->getSRutaEscudo()->c_str()+"'";
    sql = sql+")";
    return exec(sql);
}

bool CPfEquiposDAOSQLiteEntity::updateReg(CPfEquipos *reg)
{
    std::string sql("UPDATE PF_EQUIPOS SET ");
    sql = sql+" X_FK_PAIS='"+reg->getXFkPais()->c_str()+"'";
    sql = sql+",X_EQUIPO='"+reg->getXEquipo()->c_str()+"'";
    sql = sql+",S_EQUIPO='"+reg->getSEquipo()->c_str()+"'";
    sql = sql+",S_RUTA_ESCUDO='"+reg->getSRutaEscudo()->c_str()+"'";
    sql = sql+" WHERE X_EQUIPO='"+reg->getXEquipo()->c_str()+"'";
    return exec(sql);
}

CPfEquipos* CPfEquiposDAOSQLiteEntity::loadRegister(std::string sql)
{
    char *msgError = NULL;
    CPfEquipos *destiny = new CPfEquipos();
    if( sqlite3_exec(m_database, sql.c_str(), callbackRegister, destiny, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
    }
    return destiny;
}

std::vector<CPfEquipos*> * CPfEquiposDAOSQLiteEntity::loadVector(std::string sql)
{
    char *msgError = NULL;
    std::vector<CPfEquipos*> *container = new std::vector<CPfEquipos*>;
    if( sqlite3_exec(m_database, sql.c_str(), callbackVector, container, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
    }
    return container;
}

bool CPfEquiposDAOSQLiteEntity::exec(std::string sql)
{
    char *msgError = NULL;
    bool correct = true;
    if( sqlite3_exec(m_database, sql.c_str(), NULL, NULL, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
        correct = false;
    }
    return correct;
}

int CPfEquiposDAOSQLiteEntity::callbackRegister(void *object, int nColumns, char **vColumn, char **sColumn)
{
    int error = 1;
    if( object!=NULL ){
        CPfEquipos *destiny = (CPfEquipos*)object;
        for( int i=0; i<nColumns; i++ ){
            if( strcmp(sColumn[i], "X_FK_PAIS")==0 ){
                destiny->setXFkPais(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_EQUIPO")==0 ){
                destiny->setXEquipo(vColumn[i]);
            }else if( strcmp(sColumn[i], "S_EQUIPO")==0 ){
                destiny->setSEquipo(vColumn[i]);
            }else if( strcmp(sColumn[i], "S_RUTA_ESCUDO")==0 ){
                destiny->setSRutaEscudo(vColumn[i]);
            }
        }
        error = 0; // All OK
    }
    return error;
}

int CPfEquiposDAOSQLiteEntity::callbackVector(void *object, int nColumns, char **vColumn, char **sColumn)
{
    if( object!=NULL ){
        std::vector<CPfEquipos*> *container = (std::vector<CPfEquipos*> *)object;
        CPfEquipos *destiny = new CPfEquipos();
        for( int i=0; i<nColumns; i++ ){
            if( strcmp(sColumn[i], "X_FK_PAIS")==0 ){
                destiny->setXFkPais(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_EQUIPO")==0 ){
                destiny->setXEquipo(vColumn[i]);
            }else if( strcmp(sColumn[i], "S_EQUIPO")==0 ){
                destiny->setSEquipo(vColumn[i]);
            }else if( strcmp(sColumn[i], "S_RUTA_ESCUDO")==0 ){
                destiny->setSRutaEscudo(vColumn[i]);
            }
        }
        container->push_back(destiny);
    }
    return 0; // All OK
}

