/******************************************************************************
* Copyright (C) 2008 - Ikaro Games   www.ikarogames.com                       *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                             *
*                                                                             *
*       generated by dia/DAOcodegen.py                                        *
*       Version: 1.6                                                          *
******************************************************************************/

#include <stdlib.h>

#include "CPfGameOptionsDAOSQLiteEntity.h"
#include "../../../../../utils/CLog.h"

CPfGameOptionsDAOSQLiteEntity::CPfGameOptionsDAOSQLiteEntity(sqlite3 *database)
{
    m_database = database;
}

CPfGameOptionsDAOSQLiteEntity::~CPfGameOptionsDAOSQLiteEntity()
{
}

bool CPfGameOptionsDAOSQLiteEntity::deleteReg(CPfGameOptions *reg)
{
    std::string sql("DELETE FROM PF_GAME_OPTIONS WHERE X_OPTION=");
    sql = sql+"'"+reg->getXOption()+"'";
    return exec(sql);
}

bool CPfGameOptionsDAOSQLiteEntity::insertReg(CPfGameOptions *reg)
{
    std::string sql("INSERT INTO PF_GAME_OPTIONS (S_CATEGORY,X_FK_GAME,X_OPTION,S_VALUE,S_ATTRIBUTE) VALUES (");
    sql = sql+" '"+reg->getSCategory()+"'";
    sql = sql+",'"+reg->getXFkGame()+"'";
    sql = sql+",'"+reg->getXOption()+"'";
    sql = sql+",'"+reg->getSValue()+"'";
    sql = sql+",'"+reg->getSAttribute()+"'";
    sql = sql+")";
    return exec(sql);
}

bool CPfGameOptionsDAOSQLiteEntity::updateReg(CPfGameOptions *reg)
{
    std::string sql("UPDATE PF_GAME_OPTIONS SET ");
    sql = sql+" S_CATEGORY='"+reg->getSCategory()+"'";
    sql = sql+",X_FK_GAME='"+reg->getXFkGame()+"'";
    sql = sql+",X_OPTION='"+reg->getXOption()+"'";
    sql = sql+",S_VALUE='"+reg->getSValue()+"'";
    sql = sql+",S_ATTRIBUTE='"+reg->getSAttribute()+"'";
    sql = sql+" WHERE X_OPTION='"+reg->getXOption()+"'";
    return exec(sql);
}

void CPfGameOptionsDAOSQLiteEntity::freeVector(std::vector<CPfGameOptions*>* vector )
{
    std::vector<CPfGameOptions*>::iterator it;
    for( it=vector->begin(); it!=vector->end(); it++ ){
        delete (*it);
        (*it) = NULL;
    }
    delete vector;
}

CPfGameOptions* CPfGameOptionsDAOSQLiteEntity::loadRegister(std::string sql)
{
    char *msgError = NULL;
    CPfGameOptions *destiny = new CPfGameOptions();
    if( sqlite3_exec(m_database, sql.c_str(), callbackRegister, destiny, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
    }
    return destiny;
}

std::vector<CPfGameOptions*> * CPfGameOptionsDAOSQLiteEntity::loadVector(std::string sql)
{
    char *msgError = NULL;
    std::vector<CPfGameOptions*> *container = new std::vector<CPfGameOptions*>;
    if( sqlite3_exec(m_database, sql.c_str(), callbackVector, container, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
    }
    return container;
}

bool CPfGameOptionsDAOSQLiteEntity::exec(std::string sql)
{
    char *msgError = NULL;
    bool correct = true;
    if( sqlite3_exec(m_database, sql.c_str(), NULL, NULL, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
        correct = false;
    }
    return correct;
}

int CPfGameOptionsDAOSQLiteEntity::callbackRegister(void *object, int nColumns, char **vColumn, char **sColumn)
{
    int error = 1;
    if( object!=NULL ){
        CPfGameOptions *destiny = (CPfGameOptions*)object;
        for( int i=0; i<nColumns; i++ ){
            if( strcmp(sColumn[i], "S_CATEGORY")==0 ){
                destiny->setSCategory(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FK_GAME")==0 ){
                destiny->setXFkGame(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_OPTION")==0 ){
                destiny->setXOption(vColumn[i]);
            }else if( strcmp(sColumn[i], "S_VALUE")==0 ){
                destiny->setSValue(vColumn[i]);
            }else if( strcmp(sColumn[i], "S_ATTRIBUTE")==0 ){
                destiny->setSAttribute(vColumn[i]);
            }
        }
        error = 0; // All OK
    }
    return error;
}

int CPfGameOptionsDAOSQLiteEntity::callbackVector(void *object, int nColumns, char **vColumn, char **sColumn)
{
    if( object!=NULL ){
        std::vector<CPfGameOptions*> *container = (std::vector<CPfGameOptions*> *)object;
        CPfGameOptions *destiny = new CPfGameOptions();
        for( int i=0; i<nColumns; i++ ){
            if( strcmp(sColumn[i], "S_CATEGORY")==0 ){
                destiny->setSCategory(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FK_GAME")==0 ){
                destiny->setXFkGame(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_OPTION")==0 ){
                destiny->setXOption(vColumn[i]);
            }else if( strcmp(sColumn[i], "S_VALUE")==0 ){
                destiny->setSValue(vColumn[i]);
            }else if( strcmp(sColumn[i], "S_ATTRIBUTE")==0 ){
                destiny->setSAttribute(vColumn[i]);
            }
        }
        container->push_back(destiny);
    }
    return 0; // All OK
}

